include:
  - template: Code-Quality.gitlab-ci.yml

image: node:18-alpine

cache:
  paths:
    - node_modules

stages:
  - Qualidade
  - Build
  - Release

code_quality:
  stage: Qualidade
  variables:
    REPORT_FORMAT: html
  artifacts:
    paths: [gl-code-quality-report.html]
    expire_in: 1 week
    expose_as: "Code Quality Report"

Markdown:
  stage: Qualidade
  artifacts:
    when: always
    paths:
      - report-markdownlint.txt
    expire_in: 1 week
    expose_as: "Markdownlint Report"
  before_script:
    - apk --no-cache add
    - npm i -g markdownlint-cli
  script:
    - markdownlint '**/*.md' -o report-markdownlint.txt
  only:
    - main
    - next
    - merge_requests
    - /\d.(\d|x).(\d|x)(-alpha)?$/
    - /alpha$/

Commits:
  stage: Qualidade
  artifacts:
    when: always
    paths:
      - report-commitlint.txt
    expire_in: 1 week
    expose_as: "Commitlint Report"
  before_script:
    - apk --no-cache add git
    - npm i -g @govbr-ds/commit-config commitlint-gitlab-ci
  script:
    - commitlint-gitlab-ci -x @govbr-ds/commit-config > report-commitlint.txt
  only:
    - main
    - next
    - merge_requests
    - /\d.(\d|x).(\d|x)(-alpha)?$/
    - /alpha$/

tokensbuild:
  stage: Build
  artifacts:
    paths:
      - dist
      - src
    expire_in: 1 week
  script:
    - npm install
    - npm run build

  only:
    - main
    - next
    - merge_requests
    - /\d.(\d|x).(\d|x)(-alpha)?$/
    - /alpha$/

Semantic Release:
  stage: Release
  when: manual
  environment:
    name: production
  artifacts:
    paths:
      - dist
      - src
    expire_in: 1 week
  before_script:
    - apk --no-cache add git zip
  script:
    - npx semantic-release
  only:
    - main
    - next
    - /\d.(\d|x).(\d|x)(-alpha)?$/
    - /alpha$/
